<template>
  <div class="hello">
    <p>
      Result:
      {{ result }}
    </p>
    <p>Error: {{ error }}</p>
    <h3>Test QR code reader</h3>
    <button @click="toggleShow">Scan QR</button>
    <div class="qr_capture">
      <qrcode-vue
        :value="value"
        :size="size"
        level="H"
        :background="'#ffffff'"
        :foreground="'#000000'"
      ></qrcode-vue>
    </div>

    <qrcode-drop-zone>
      <qrcode-stream
        :camera="'auto'"
        v-if="scanByCamera"
        @decode="onDecode"
        @init="onInit"
      ></qrcode-stream
    ></qrcode-drop-zone>
    <qrcode-capture></qrcode-capture>
  </div>
</template>

<script>
import { QrcodeStream, QrcodeDropZone, QrcodeCapture } from "vue-qrcode-reader";
import QrcodeVue from "qrcode.vue";
export default {
  name: "HelloWorld",
  components: {
    QrcodeVue,
    QrcodeStream,
    QrcodeDropZone,
    QrcodeCapture,
  },
  data: () => {
    return {
      value: "https://example.com",
      size: 100,
      scanByCamera: false,
      error: "",
      result: "",
    };
  },
  methods: {
    toggleShow() {
      this.scanByCamera = !this.scanByCamera;
      this.result = "";
    },
    onDecode(decodedString) {
      this.result = decodedString;
    },
    async onInit(promise) {
      try {
        await promise;
      } catch (error) {
        if (error.name === "NotAllowedError") {
          this.error = "ERROR: you need to grant camera access permisson";
        } else if (error.name === "NotFoundError") {
          this.error = "ERROR: no camera on this device";
        } else if (error.name === "NotSupportedError") {
          this.error = "ERROR: secure context required (HTTPS, localhost)";
        } else if (error.name === "NotReadableError") {
          this.error = "ERROR: is the camera already in use?";
        } else if (error.name === "OverconstrainedError") {
          this.error = "ERROR: installed cameras are not suitable";
        } else if (error.name === "StreamApiNotSupportedError") {
          this.error = "ERROR: Stream API is not supported in this browser";
        }
      }
    },
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style>
.qr_capture {
  display: flex;
  width: 100%;
  justify-content: center;
  align-items: center;
  height: 200px;
}
h3 {
  margin: 40px 0 0;
}
ul {
  list-style-type: none;
  padding: 0;
}
li {
  display: inline-block;
  margin: 0 10px;
}
a {
  color: #42b983;
}
</style>
